"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _hapi = _interopRequireDefault(require("hapi"));

var _ = _interopRequireDefault(require("./"));

var testServer = function testServer(test) {
  var server = _hapi.default.server({
    port: 0
  });

  return server.register(_.default).then(function () {
    return server.route({
      method: 'GET',
      path: '/{wild*}',
      handler: function handler(request, h) {
        return 'okay';
      }
    });
  }).then(function () {
    return server.inject({
      url: '/ping'
    });
  }).then(test).then(function () {
    return server.stop();
  }).catch(function (err) {
    server.stop();
    throw err;
  });
};

describe('mwp logger', function () {
  it('sets server.app.logger', function () {
    testServer(function (response) {
      expect(response.request.server.app.logger).toBeDefined();
    });
  });
});
//# sourceMappingURL=index.test.js.map