"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

/*
 * Generic formatting for Datadog logging.
 *
*/
var METRIC = {
  COUNT: 'count',
  GAUGE: 'gauge',
  SET: 'set',
  TIMING: 'timing'
};
var invalidCharacters = /[^a-zA-Z0-9._]+/g;

var cleanKey = function cleanKey(key) {
  var noInvalidChars = key.replace(invalidCharacters, '.');
  var noExtraPeriods = noInvalidChars.replace(/\\.+/g, '.');
  var noPeriodLeft = noExtraPeriods.replace(/^\\.+/, '');
  var noPeriodRight = noPeriodLeft.replace(/\\.+$/g, '');
  return noPeriodRight;
};

var metricFormatter = function metricFormatter(metric, key, value) {
  // in order for log entries to make it to datadog they must
  // be logged with a key value format of
  // { @timestamp: value, message: value }
  console.log(JSON.stringify({
    '@timestamp': "".concat(new Date().toString()),
    message: "metric.".concat(metric, ".").concat(cleanKey(key), "=").concat(value)
  }));
};

var MetricLogging =
/*#__PURE__*/
function () {
  function MetricLogging(serviceKey) {
    (0, _classCallCheck2.default)(this, MetricLogging);
    this.serviceKey = serviceKey;
  }

  (0, _createClass2.default)(MetricLogging, [{
    key: "makeKey",
    value: function makeKey(key) {
      return "".concat(this.serviceKey, ".").concat(key);
    }
  }, {
    key: "inc",
    value: function inc(key, value) {
      metricFormatter(METRIC.COUNT, this.makeKey(key), value + 1);
    }
  }, {
    key: "dec",
    value: function dec(key, value) {
      metricFormatter(METRIC.COUNT, this.makeKey(key), value - 1);
    }
  }, {
    key: "gauge",
    value: function gauge(key, value) {
      metricFormatter(METRIC.GAUGE, this.makeKey(key), value);
    }
  }, {
    key: "set",
    value: function set(key, value) {
      metricFormatter(METRIC.SET, this.makeKey(key), value);
    }
  }, {
    key: "timing",
    value: function timing(key, value) {
      metricFormatter(METRIC.TIMING, this.makeKey(key), value);
    }
  }]);
  return MetricLogging;
}();

module.exports = MetricLogging;
//# sourceMappingURL=metric.js.map